unit U_GetDllForm;

interface

uses
  Windows, Messages, forms, OleCtnrs, DateUtils, SysUtils, ADODB, dxCore,
  ActiveX;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd; export; stdcall;

function ConnData(): Boolean;

implementation

uses
  U_DataLink, U_FHSQList, U_PBOutHZList, U_SQSMCK, U_SMPK, U_FHSQListHD;
       /////////////////////////////////////////////////////////////////
      //         功能说明:取Dll中得窗体                              //
     //        参数说明：App>>调用应用程序；                        //
    //                 FormH>>调用窗口句柄 ；                      //
   //                 FormID>>窗口号;                             //
  //                 Language>>语言种类;                         //
 //                 WinStyle>>窗口类型；                        //
/////////////////////////////////////////////////////////////////

var
  frmFHSQListLR, frmFHSQListGQX, frmFHSQListChk, frmFHSQListChkDW: TfrmFHSQList;
  frmPBOutHZListGL, frmPBOutHZListCX: TfrmPBOutHZList;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd;
var
  i: Integer;
  bFound: Boolean;
  mnewHandle: hwnd;
  mstyle: TFormStyle;     // 0:子窗口; 1：普通窗口
  mstate: TWindowState;
  mborderstyle: TFormBorderStyle;
begin
  mnewHandle := 0;
  DName := PChar(GName);
  DCode := PChar(GCode);
  DdataBase := DataBase;
  DTitCaption := Title;
  DParameters1 := Parameters1;
  DParameters2 := Parameters2;
  DParameters3 := Parameters3;
  DParameters4 := Parameters4;
  DParameters5 := Parameters5;
  DParameters6 := Parameters6;
  DParameters7 := Parameters7;
  DParameters8 := Parameters8;
  DParameters9 := Parameters9;
  DParameters10 := Parameters10;

  MainApplication := App;
  DCurHandle := FormH;
  IsDelphiLanguage := Language;

  Application := TApplication(App);
  DCurHandle := 0;


   //赋值链接字符串
  SetLength(server, 255);
  SetLength(dtbase, 255);
  SetLength(user, 255);
  SetLength(pswd, 255);
  if trim(DataBaseStr) = '' then
  begin
    server := '139.196.189.214,7781';
//  server := '.';
    dtbase := 'yongjindata';
    user := 'yifusa';
    pswd := 'rightsoft@123';
//  pswd := 'rightsoft';
    DConString := 'Provider=SQLOLEDB.1;Password=' + pswd + ';Persist Security Info=True;User ID=' + user + ';Initial Catalog=' + dtbase + ';Data Source=' + server;

    //DName := '美霞';
    //DCode := '201HMX';
//   DParameters1:='高权限';
   //DParameters3:='1';
  end
  else
  begin
    DConString := DataBaseStr;
  end;

  if not ConnData() then
  begin
    result := 0;
    exit;
  end;

   // 定义窗口类型 、状态
  if WinStyle = 0 then
  begin
    mstyle := fsMDIChild;
    mstate := wsMaximized;
    mborderstyle := bsSizeable;
  end
  else
  begin
    mstyle := fsNormal;
    mstate := wsNormal;
    mborderstyle := bsSizeable;
  end;
  /////////////////////
  //调用子模块窗口
  case FormID of
    111:  //发货申请
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '发货申请' then
          begin
            BringWindowToTop(frmFHSQListLR.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmFHSQListLR := TfrmFHSQList.Create(application.MainForm);
          with frmFHSQListLR do
          begin
            Title := '发货申请';
            canshu1 := '录入';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmFHSQListLR.BringToFront;
       //句柄
        mnewHandle := frmFHSQListLR.Handle;
      end;
    112:  //发货申请(高权限)
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '发货申请(高权限)' then
          begin
            BringWindowToTop(frmFHSQListGQX.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmFHSQListGQX := TfrmFHSQList.Create(application.MainForm);
          with frmFHSQListGQX do
          begin
            Title := '发货申请(高权限)';
            canshu1 := '高权限';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmFHSQListGQX.BringToFront;
       //句柄
        mnewHandle := frmFHSQListGQX.Handle;
      end;
    113:  //发货申请审核
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '发货申请审核' then
          begin
            BringWindowToTop(frmFHSQListChk.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmFHSQListChk := TfrmFHSQList.Create(application.MainForm);
          with frmFHSQListChk do
          begin
            Title := '发货申请审核';
            canshu1 := '审核';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmFHSQListChk.BringToFront;
       //句柄
        mnewHandle := frmFHSQListChk.Handle;
      end;
    115:  //对外销售审核
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '对外销售审核' then
          begin
            BringWindowToTop(frmFHSQListChkDW.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmFHSQListChkDW := TfrmFHSQList.Create(application.MainForm);
          with frmFHSQListChkDW do
          begin
            Title := '对外销售审核';
            canshu1 := '对外审核';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmFHSQListChkDW.BringToFront;
       //句柄
        mnewHandle := frmFHSQListChkDW.Handle;
      end;
    116:  //对外销售核对
      begin
        if frmFHSQListHD = nil then
        begin
          frmFHSQListHD := TfrmFHSQListHD.Create(application.MainForm);
          with frmFHSQListHD do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmFHSQListHD.BringToFront;
       //句柄
        mnewHandle := frmFHSQListHD.Handle;

      end;

    201:  //扫描出库
      begin
        if frmSQSMCK = nil then
        begin
          frmSQSMCK := TfrmSQSMCK.Create(application.MainForm);
          with frmSQSMCK do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmSQSMCK.BringToFront;
       //句柄
        mnewHandle := frmSQSMCK.Handle;

      end;

    121:  //码单打印
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '码单打印' then
          begin
            BringWindowToTop(frmPBOutHZListGL.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmPBOutHZListGL := TfrmPBOutHZList.Create(application.MainForm);
          with frmPBOutHZListGL do
          begin
            Title := '码单打印';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmPBOutHZListGL.BringToFront;
       //句柄
        mnewHandle := frmPBOutHZListGL.Handle;
      end;

    122:  //码单查询
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '码单查询' then
          begin
            BringWindowToTop(frmPBOutHZListCX.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmPBOutHZListCX := TfrmPBOutHZList.Create(application.MainForm);
          with frmPBOutHZListCX do
          begin
            Title := '码单查询';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmPBOutHZListCX.BringToFront;
       //句柄
        mnewHandle := frmPBOutHZListCX.Handle;
      end;
    311:  //扫描盘库
      begin
        if frmSMPK = nil then
        begin
          frmSMPK := TfrmSMPK.Create(application.MainForm);
          with frmSMPK do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmSMPK.BringToFront;
       //句柄
        mnewHandle := frmSMPK.Handle;

      end;
  end;

  Result := mnewHandle;

end;
//===========================================================
  //建立数据库连接池
//===========================================================

function ConnData(): Boolean;
begin
  if not Assigned(DataLink_ShipmentRequest) then
    DataLink_ShipmentRequest := TDataLink_ShipmentRequest.Create(Application);
  try
    with DataLink_ShipmentRequest.ADOLink do
    begin
      //if not Connected then
      begin
        Connected := false;
        ConnectionString := DConString;
        LoginPrompt := false;
        Connected := true;
      end;
    end;
    Result := true;
  except
    Result := false;
    application.MessageBox('数据库连接失败！', '错误', mb_Ok + MB_ICONERROR);
  end;

end;

initialization
  CoInitialize(nil);
  dxUnitsLoader.Initialize;


finalization
  DataLink_ShipmentRequest.Free;
  application := NewDllApp;
  dxUnitsLoader.Finalize;

end.

